{-# LANGUAGE TypeFamilies #-}
module GenericLambda where 

-- dumb attempt to generalize my lambda calculus functions

-- This typeclass encompasses a generic "lambda calculus" language, but it can be 
-- more flexible than that.
class GenericLambda l where 
  data Env l -- The type encompassing the environment, and actually the entire state of the language.
  type Iden l -- The type of identifiers.
  type Data l -- The type representing usually an expression + type information if necessary.
  data PRes l -- the type representing a parsing result.
  emptyEnv :: Env l -- the empty environment.
  updateEnv :: Env l -> Iden l -> Data l -> Env l -- function to update the environment.
  envStrings :: Env l -> [(String, String)] -- function to show the environment for tab completions.
  normalform :: Env l -> Data l -> Either String String -- function to reduce some expression.
  execLine :: Env l -> String -> IO (Maybe String, Env l) -- function to execute 1 line of "code".


evalPrint' :: (GenericLambda l) => Env l -> Data l -> String 
evalPrint' en ex = case normalform en ex of 
  Right res -> "-> " ++ res 
  Left err -> err
